#
# spec file for package java-1_6_0-ibm
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# nodebuginfo

%define plugin_arches %{ix86} ppc x86_64

Name:           java-1_6_0-ibm
BuildRequires:  dos2unix jpackage-utils unzip update-alternatives update-desktop-files
%ifarch %ix86 ppc ppc64
BuildRequires:  libstdc++33
%endif
%define section         non-free
%ifarch x86_64
%define target_cpu x86_64
%define filename_substring x86_64
%define __arch amd64
%endif
%ifarch s390
%define target_cpu s390
%define filename_substring s390
%endif
%ifarch s390x
%define target_cpu s390x
%define filename_substring s390x
%endif
%ifarch ppc
%define target_cpu ppc
%define filename_substring ppc
%define __arch ppc
%endif
%ifarch ppc64
%define target_cpu ppc64
%define filename_substring ppc64
%endif
%ifarch %ix86
%define target_cpu i386
%define filename_substring i386
%define __arch i386
%endif
%define origin          ibm
%define priority        1610
%define javaver         1.6.0
%define cvsver          1_6_0
%define buildver        9.0
%define release         1jpp
# TODO: Think about using conditionals for version variants.
%define version         %{javaver}.%{buildver}
%define cvsversion      %{cvsver}_%{buildver}
%define javaws_ver      %{javaver}
%define javaws_version  %{cvsversion}
%define toplevel_dir    ibm-java-%{target_cpu}-60
%define sdklnk          java-%{javaver}-%{origin}
%define jrelnk          jre-%{javaver}-%{origin}
%define sdkdir          java-%{javaver}-%{origin}-%{javaver}
%define demodir         %{_jvmdir}/%{sdkdir}/demo
%define jredir          %{sdkdir}/jre
%define sdkbindir       %{_jvmdir}/%{sdklnk}/bin
%define sdklibdir       %{_jvmdir}/%{sdklnk}/lib
%define jrebindir       %{_jvmdir}/%{jrelnk}/bin
%define jvmjardir       %{_jvmjardir}/java-%{javaver}-%{origin}-%{javaver}
%define x11bindir       %{_prefix}/X11R6/bin
%define x11encdir       %{_prefix}/X11R6/lib/X11/fonts/encodings
%define fontconfigdir   %{_sysconfdir}/fonts
%define fontdir         %{_datadir}/fonts/java
%define pluginsdir      %{_libdir}/browser-plugins
%define pluginpath      %{_jvmdir}/%{jredir}/lib/%{__arch}/
%define pluginname      libnpjp2.so
%define cgibindir       /srv/www/cgi-bin
# Avoid RPM 4.2+'s internal dep generator, it may produce bogus
# Provides/Requires here.
%define _use_internal_dependency_generator 0
Version:        1.6.0_sr%{buildver}
Release:        1.8.2
Summary:        Java(TM) 6 Runtime Environment
License:        "IBM ILAN ..."
Group:          Development/Languages/Java
Url:            http://www-128.ibm.com/developerworks/java/jdk/
Source0:        ibm-java-sdk-6.0-%{buildver}-linux-%{filename_substring}.tar.bz2
NoSource:       0
Source6:        wrapper-script
Source7:        font.properties.SuSE.tar.gz
Source8:        baselibs.conf
Source20:       patch.sh
Source21:       Moh.class
Source22:       jtzu-1.6.10b.zip
NoSource:       22
%define         tzupdate false
Source100:      java-1_6_0-ibm-rpmlintrc
Provides:       jre-%{javaver}-%{origin} = %{version}-%{release}
Provides:       jre-%{origin} = %{version}-%{release}
Provides:       jre-%{javaver}, java-%{javaver}, jre = %{javaver}
Provides:       java-%{origin} = %{version}-%{release}
Provides:       java = %{javaver}
PreReq:         update-alternatives
PreReq:         coreutils
Requires:       jpackage-utils >= 1.5.38
# bnc#459800
Requires:       java-fonts >= %{javaver}
%ifarch %ix86
#Requires:       %{name}-alsa
%endif
ExclusiveArch:  %ix86 ppc ppc64 s390 s390x x86_64
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%ifarch %{plugin_arches}
Provides:       javaws = %{javaws_ver}
%endif
Provides:       jndi = %{javaver}, jndi-ldap = %{javaver}
Provides:       jndi-cos = %{javaver}, jndi-rmi = %{javaver}
Provides:       jndi-dns = %{javaver}
Provides:       jaas = %{javaver}
Provides:       jsse = %{javaver}
Provides:       jce = %{javaver}
Provides:       jdbc-stdext = 3.0, jdbc-stdext = %{version}
%ifarch ppc64
Provides:       j9vm/libjvm.so
%endif
Provides:       java-sasl = %{version}
Provides:       jre1.1.x jre1.2.x jre1.3.x jre1.4.x jre1.5.x jre1.6.x
Obsoletes:      java2-jre
Provides:       java2-jre
PreReq:         /usr/sbin/update-alternatives
Provides:       j2re = 1.6.0, j2re
# 32-bit versus 64-bit specific provides:
%ifarch %ix86 ppc s390
%define bits 32
%endif
%ifarch x86_64 ppc64 ia64 s390x
%define bits 64
%endif
Provides:       jre-%{javaver}-%{origin}-%{bits} = %{version}-%{release}
Provides:       jre-%{origin}-%{bits} = %{version}-%{release}
Provides:       jre-%{javaver}-%{bits}, java-%{javaver}-%{bits}
Provides:       jre-%{bits} = %{javaver}
Provides:       java-%{origin}-%{bits} = %{version}-%{release}
Provides:       java-%{bits} = %{javaver}
Provides:       jndi-%{bits}, jdbc-stdext-%{bits}

%description
Java(TM) 6 Runtime Environment

The Java(TM) 6 Runtime Environment contains the Java virtual machine,
runtime class libraries, and Java application launcher that are
necessary to run programs written in the Java progamming language. It
is not a development environment and does not contain development tools
such as compilers and debuggers. For development tools, see the
java-1.6.0-ibm-devel package.

The Java 6 Runtime Environment is intended for software developers and
vendors who wish to redistribute their applications.



%package        devel
License:        "IBM ILAN ..."
Summary:        Java(TM) 6 SDK, Standard Edition
Group:          Development/Languages/Java
Requires:       /usr/sbin/update-alternatives
Provides:       java-sdk-%{javaver}-%{origin} = %{version}-%{release}
Provides:       java-sdk-%{origin} = %{version}-%{release}
Provides:       java-sdk-%{javaver}, java-sdk = %{javaver}
Provides:       java-devel-%{origin} = %{version}-%{release}
Provides:       java-%{javaver}-devel, java-devel = %{javaver}
Requires:       %{name} = %{version}-%{release}
Provides:       j2sdk = 1.6.0, j2sdk
PreReq:         update-alternatives

%description    devel
The Java 6 SDK is a development environment for building applications,
applets, and components using the Java programming language.

The Java 6 SDK includes tools useful for developing and testing
programs written in the Java programming language and running on the
Java platform. These tools are designed to be used from the command
line. Except for the appletviewer, these tools do not provide a
graphical user interface.



%package        src
License:        "IBM ILAN ..."
Summary:        Java(TM) 6 Runtime Environment
Group:          Development/Languages/Java
Requires:       %{name} = %{version}-%{release}

%description    src
Java(TM) 6 Runtime Environment

The Java(TM) 6 Runtime Environment contains the Java virtual machine,
runtime class libraries, and Java application launcher that are
necessary to run programs written in the Java progamming language. It
is not a development environment and does not contain development tools
such as compilers and debuggers. For development tools, see the
java-1.6.0-ibm-devel package.

The Java 6 Runtime Environment is intended for software developers and
vendors who wish to redistribute their applications.



%package        demo
License:        "IBM ILAN ..."
Summary:        Demonstration files for java-1.6.0-ibm
Group:          Development/Languages/Java
Requires:       %{name} = %{version}-%{release}
# Without this a requirement on libjava_crw_demo_g.so is added which
# is not in the main java package. libjava_crw_demo.so is but not "_g".
AutoReq:        0

%description    demo
This package contains demonstration files for java-1.6.0-ibm.



%ifarch %{plugin_arches}

%package        plugin
License:        "IBM ILAN ..."
Summary:        Browser plugin files for java-1.6.0-ibm
Group:          Development/Languages/Java
Requires:       %{name} = %{version}-%{release}
Requires:       %{_bindir}/find, sed
Provides:       java-plugin = %{javaver}, java-%{javaver}-plugin = %{version}
# This is well handled by update-alternatives system!
#Conflicts:      java-%{javaver}-sun-plugin, java-%{javaver}-blackdown-plugin
#Conflicts:      java-%{javaver}-bea-plugin

#bnc#658220 - don't Provide/Obsolete Java plugin on x86_64
%ifnarch x86_64
Obsoletes:      java-1.3.1-plugin, java-1.4.0-plugin, java-1.4.1-plugin, java-1.4.2-plugin
Provides:       java-1.3.1-plugin, java-1.4.0-plugin, java-1.4.1-plugin, java-1.4.2-plugin
%endif

%description    plugin
This package contains browser plugin files for java-1.6.0-ibm. Note:
this package supports browsers built with GCC 3.2 and later



%endif

%package        fonts
License:        "IBM ILAN ..."
Summary:        Java(TM) 2 Runtime Environment
Group:          Development/Languages/Java
Provides:       java-fonts = %{javaver}, java-%{javaver}-fonts
Conflicts:      java-%{javaver}-sun-fonts, java-%{javaver}-blackdown-fonts
Conflicts:      java-%{javaver}-bea-fonts
Obsoletes:      java-1.3.1-fonts, java-1.4.0-fonts, java-1.4.1-fonts, java-1.4.2-fonts, java-1.6.0-fonts
Provides:       java-1.3.1-fonts, java-1.4.0-fonts, java-1.4.1-fonts, java-1.4.2-fonts, java-1.6.0-fonts

%description    fonts
Java(TM) 2 Runtime Environment

The Java(TM) 2 Runtime Environment contains the Java virtual machine,
runtime class libraries, and Java application launcher that are
necessary to run programs written in the Java progamming language. It
is not a development environment and does not contain development tools
such as compilers and debuggers. For development tools, see the Java 2
SDK, Standard Edition.

The Java 2 Runtime Environment is intended for software developers and
vendors who wish to redistribute their applications.



%ifarch %ix86

%package        alsa
License:        "IBM ILAN ..."
Summary:        ALSA support for java-1.6.0-ibm
Group:          Development/Languages/Java
Requires:       %{name} = %{version}-%{release}

%description    alsa
This package contains Advanced Linux Sound Architecture (ALSA) support
libraries for java-1.6.0-ibm.



%endif

%package        jdbc
License:        "IBM ILAN ..."
Summary:        JDBC/ODBC bridge driver for java-1.6.0-ibm
Group:          Development/Languages/Java
AutoReq:        0
Requires:       %{name} = %{version}-%{release}
Requires:       unixODBC
Provides:       java-jdbc = %{version}

%description    jdbc
This package contains the JDBC/ODBC bridge driver for java-1.6.0-ibm.



%prep
%setup -q -n %{toplevel_dir}
# SUSE: no macro expansion in SOURCEs
# do not unpack anything, but change into toplevel_dir
cp %{SOURCE6} %{toplevel_dir}
%setup -q -T -D -n %{toplevel_dir} -a 7
find . -name "*.desktop" -delete || true
# remove splash screen, which are binaries compiled for various architectures
rm -rf docs/launchpad/splash
chmod -R go=u-w *
chmod -R u+w *
chmod 644 copyright
find docs -type f | xargs chmod 644
find . -name '*.txt' -or -name '*.c' -or -name '*.h' | xargs chmod 0644
if [ "%tzupdate" = "true" ]
then
sh %{SOURCE20} %{SOURCE22} $(pwd) %{SOURCE21} && rm -rf jre/lib/zi_jtzubackup
fi
find docs/ -type 'f' | xargs dos2unix
find . -iname '*.exe' -o -iname '*.bat' | xargs rm -f

%build
# Nope.

%install
#bnc#538528 - not modify binaries!
export NO_DEBUGINFO_STRIP_DEBUG=true
%define __debug_install_post %{nil}
export NO_BRP_CHECK_BYTECODE_VERSION="true"
export NO_BRP_CHECK_RPATH="true"
export NO_BRP_STRIP_DEBUG="true"

if [ -f bin/java-rmi.cgi ]; then
# install java-rmi-cgi
install -D -m 755 bin/java-rmi.cgi $RPM_BUILD_ROOT%{cgibindir}/java-rmi-%{version}.cgi 
# fix up java-rmi.cgi PATH
perl -p -i -e 's|PATH=.*|PATH=%{jrebindir}|' $RPM_BUILD_ROOT%{cgibindir}/java-rmi-%{version}.cgi 
fi

# main files
install -d -m 755 $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}
cp -a bin include lib src.zip $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}
(cd $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir} && ln -s src.zip src.jar)
install -d -m 755 $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}
# extensions handling
install -d -m 755 $RPM_BUILD_ROOT%{jvmjardir}
pushd $RPM_BUILD_ROOT%{jvmjardir}
   ln -s %{_jvmdir}/%{jredir}/lib/ibmjsseprovider2.jar jsse-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/ibmjcefw.jar jce-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/rt.jar jndi-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/rt.jar jndi-ldap-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/rt.jar jndi-cos-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/rt.jar jndi-rmi-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/rt.jar jaas-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/rt.jar jdbc-stdext-%{version}.jar
   ln -s jdbc-stdext-%{version}.jar jdbc-stdext-3.0.jar
   ln -s %{_jvmdir}/%{jredir}/lib/rt.jar sasl-%{version}.jar
   for jar in *-%{version}.jar ; do
      if [ x%{version} != x%{javaver} ]; then
         ln -fs ${jar} $(echo $jar | sed "s|-%{version}.jar|-%{javaver}.jar|g")
      fi
      ln -fs ${jar} $(echo $jar | sed "s|-%{version}.jar|.jar|g")
   done
popd
# rest of the jre
cp -a jre/bin jre/lib $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}
%ifarch %{plugin_arches}
cp -a jre/javaws $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}
cp -a jre/plugin $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}
%endif
install -d -m 755 $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}/lib/endorsed
# jce policy file handling
install -d -m 755 $RPM_BUILD_ROOT%{_jvmprivdir}/%{name}/jce/vanilla
for file in local_policy.jar US_export_policy.jar; do
  mv $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}/lib/security/$file \
    $RPM_BUILD_ROOT%{_jvmprivdir}/%{name}/jce/vanilla
  # for ghosts
  touch $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}/lib/security/$file
done
# versionless symlinks
pushd $RPM_BUILD_ROOT%{_jvmdir}
ln -s %{jredir} %{jrelnk}
ln -s %{sdkdir} %{sdklnk}
popd
pushd $RPM_BUILD_ROOT%{_jvmjardir}
ln -s %{sdkdir} %{jrelnk}
ln -s %{sdkdir} %{sdklnk}
popd
%ifarch %{plugin_arches}
# freedesktop.org menu entry for console
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/applications
cat <<EOF > $RPM_BUILD_ROOT%{_datadir}/applications/jpackage-%{name}-ControlPanel.desktop
[Desktop Entry]
Name=IBM Java %{version} Java Plug-in Control Panel
GenericName=Java Plugin Control Panel
Comment=IBM Java %{version} Java Plug-in Control Panel
Exec=%{_jvmdir}/%{jredir}/bin/ControlPanel
Icon=ibm-java-%{version}-%{release}.png
Terminal=false
Type=Application
Encoding=UTF-8
EOF
%suse_update_desktop_file -r $RPM_BUILD_ROOT%{_datadir}/applications/jpackage-%{name}-ControlPanel.desktop Java System SystemSetup
install -Dpm 644 demo/jfc/Metalworks/src/resources/HelpFiles/javalogo.gif \
  $RPM_BUILD_ROOT%{_datadir}/pixmaps/ibm-java-%{version}-%{release}.png
# menu entry for web start (reuse plugin control panel icon)
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/applications
install -Dpm 644 demo/jfc/Metalworks/src/resources/HelpFiles/javalogo.gif \
  $RPM_BUILD_ROOT%{_datadir}/pixmaps/ibm-java-%{version}-%{release}.png
cat <<EOF > $RPM_BUILD_ROOT%{_datadir}/applications/jpackage-%{name}-webstart.desktop
[Desktop Entry]
Name=IBM  Java %{version} Java Web Start
GenericName=Java Web Start
Comment=Java Web Start Application Manager
Exec=%{_jvmdir}/%{jredir}/javaws/javaws
Icon=ibm-java-%{version}-%{release}.png
Terminal=false
Type=Application
Encoding=UTF-8
Categories=Application;System;Java;X-JPackage;
EOF
chmod 644 $RPM_BUILD_ROOT%{_datadir}/applications/jpackage-%{name}-webstart.desktop
%suse_update_desktop_file -r $RPM_BUILD_ROOT%{_datadir}/applications/jpackage-%{name}-webstart.desktop Java System Monitor 
%endif
# demo
install -d -m 755 $RPM_BUILD_ROOT%{demodir}
cp -a demo/* $RPM_BUILD_ROOT%{demodir}
# install also samples, if possible
if [[ -d samples ]]; then
install -d -m 755 $RPM_BUILD_ROOT%{demodir}/samples
cp -a samples/* $RPM_BUILD_ROOT%{demodir}
fi
### font handling
pushd $RPM_BUILD_ROOT/%{_jvmdir}/%{jredir}/lib
   # Remove font.properties and use the system-wide one -- NiM
   rm -f font.properties
   ln -fs %{_sysconfdir}/java/font.properties .
   # remove supplied fonts.dir in preference of the one to be dynamically generated -- Rex
   rm fonts/fonts.dir
   # These %ghost'd files are created properly in %post  -- Rex
   touch fonts/{fonts.{alias,dir,scale,cache-1},XftCache,encodings.dir}
   if [ "%{fontdir}" != "%{jredir}/lib/fonts" ] ; then
      install -d -m 755 $RPM_BUILD_ROOT%{fontdir}
      mv fonts/* $RPM_BUILD_ROOT%{fontdir}
      rmdir fonts
      ln -fs %{fontdir} fonts
   fi
popd
# font registration/unregistration
# Most of this shamelessly stolen from redhat's kdebase-2.2.2 specfile
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type d \
  | grep -v "jre\/lib\/locale" | sed 's|'$RPM_BUILD_ROOT'|%dir |' >  %{name}-%{version}-all.files
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type f -o -type l \
  | sed 's|'$RPM_BUILD_ROOT'||'      >> %{name}-%{version}-all.files
%ifarch %{plugin_arches}
grep plugin  %{name}-%{version}-all.files | sort \
  > %{name}-%{version}-plugin.files
%endif
grep Jdbc    %{name}-%{version}-all.files | sort \
  > %{name}-%{version}-jdbc.files
%ifarch %ix86
grep -F alsa.so %{name}-%{version}-all.files | sort \
  > %{name}-%{version}-alsa.files
%endif
cat %{name}-%{version}-all.files \
  | grep -v plugin \
  | grep -v Jdbc \
  | grep -v properties \
  | grep -v lib/fonts \
  | grep -vF alsa.so \
  | grep -v "jre\/lib\/security" \
  > %{name}-%{version}.files
cat %{name}-%{version}-all.files | grep "jre.*properties" | sed 's/.*/%attr(0644,root,root) &/g' >> %{name}-%{version}.files
# index jar files
#JAR_EXECUTABLE=$(readlink -f $(find %{_builddir} -name "jar"))
#find $RPM_BUILD_ROOT \( -name "*.jar" -a -type f -a ! -empty \) -exec $JAR_EXECUTABLE -i {} \;
# replace windows \r\n newline by unix \n
find $RPM_BUILD_ROOT \( -name "*.MF" -o -name "*.bat" -o -name "*.css" -o -name "*.frameset" -o -name "*.head" -o -name "*.htm" -o -name "*.html" -o -name "*.inf" -o -name "*.ini" -o -name "*.js" -o -name "*.properties" -o -name "*.txt" -o -name "copyright" -o -name "package-list" \) -exec sed -i -e "s/\r//g" {} \;
# bnc#394974
install -d -m 0755 $RPM_BUILD_ROOT/%{_jvmdir}/%{jredir}/.systemPrefs
# HACK FOR DISABLED DEBUG
echo "/usr/lib/debug" > debugfiles.list
mkdir -p $RPM_BUILD_ROOT/usr/lib/debug
echo "/usr/src/debug" > debugsources.list
mkdir -p $RPM_BUILD_ROOT/usr/src/debug

%clean
rm -rf $RPM_BUILD_ROOT

%preun fonts

%ifarch %{plugin_arches}

%post plugin
  # set link to plugin lib
  cd %{pluginsdir}
  JAVAPLUGINS=$(ls -1 | grep "\(java\|gcj\)" | grep -v javaplugin.so || true)
  if [ -n "$JAVAPLUGINS" ]
  then
    rm -rf $JAVAPLUGINS || true
  fi
  /usr/sbin/update-alternatives --install %{pluginsdir}/javaplugin.so javaplugin %{pluginpath}/%{pluginname} %{priority}

%preun plugin
  if [ "$1" = "0" ] ; then
  /usr/sbin/update-alternatives --remove javaplugin %{pluginpath}/%{pluginname}
  fi
%endif

%post
update-alternatives --install %{_bindir}/java java %{jrebindir}/java %{priority} \
%ifarch %{plugin_arches}
--slave %{_bindir}/ControlPanel            ControlPanel                %{jrebindir}/ControlPanel \
--slave %{_datadir}/javaws                 javaws                      %{jrebindir}/javaws \
%endif
--slave %{_jvmdir}/jre                     jre                         %{_jvmdir}/%{jrelnk} \
--slave %{_jvmjardir}/jre                  jre_exports                 %{_jvmjardir}/%{jrelnk} \
--slave %{_bindir}/keytool                 keytool                     %{jrebindir}/keytool \
--slave %{_bindir}/policytool              policytool                  %{jrebindir}/policytool \
--slave %{_bindir}/rmid                    rmid                        %{jrebindir}/rmid \
--slave %{_bindir}/rmiregistry             rmiregistry                 %{jrebindir}/rmiregistry \
--slave %{_bindir}/tnameserv               tnameserv                   %{jrebindir}/tnameserv
update-alternatives --install %{_jvmdir}/jre-%{origin} jre_%{origin} %{_jvmdir}/%{jrelnk} %{priority} \
--slave %{_jvmjardir}/jre-%{origin}        jre_%{origin}_exports     %{_jvmjardir}/%{jrelnk}
update-alternatives --install %{_jvmdir}/jre-%{javaver} jre_%{javaver} %{_jvmdir}/%{jrelnk} %{priority} \
--slave %{_jvmjardir}/jre-%{javaver}       jre_%{javaver}_exports      %{_jvmjardir}/%{jrelnk}
if [ -d %{_jvmdir}/%{jrelnk}/lib/security ]; then
  # Need to remove the old jars in order to support upgrading, ugly :(
  # update-alternatives fails silently if the link targets exist as files.
  rm -f %{_jvmdir}/%{jrelnk}/lib/security/{local,US_export}_policy.jar
fi
update-alternatives \
  --install \
    %{_jvmdir}/%{jrelnk}/lib/security/local_policy.jar \
    jce_%{javaver}_%{origin}_local_policy \
    %{_jvmprivdir}/%{name}/jce/vanilla/local_policy.jar \
    %{priority} \
  --slave \
    %{_jvmdir}/%{jrelnk}/lib/security/US_export_policy.jar \
    jce_%{javaver}_%{origin}_us_export_policy \
    %{_jvmprivdir}/%{name}/jce/vanilla/US_export_policy.jar
%ifarch %{plugin_arches}
if [ -f %{_sysconfdir}/mime.types ]; then
    if ! grep -q "application/x-java-jnlp-file" %{_sysconfdir}/mime.types; then
        echo "application/x-java-jnlp-file      jnlp" >> %{_sysconfdir}/mime.types 2>/dev/null
    fi
fi
if [ -f %{_sysconfdir}/mailcap ]; then
    #We need remove tons of duplicate jnlp entries in mailcap
    sed -i '/.*application\/x-java-jnlp-file.*/d' %{_sysconfdir}/mailcap
    echo 'application/x-java-jnlp-file;/usr/bin/javaws "%s"' >> %{_sysconfdir}/mailcap 2>/dev/null
fi
%endif

%post devel
update-alternatives --install %{_bindir}/javac javac %{sdkbindir}/javac %{priority} \
--slave %{_jvmdir}/java                     java_sdk                    %{_jvmdir}/%{sdklnk} \
--slave %{_jvmjardir}/java                  java_sdk_exports            %{_jvmjardir}/%{sdklnk} \
--slave %{_bindir}/appletviewer             appletviewer                %{sdkbindir}/appletviewer \
--slave %{_bindir}/extcheck                 extcheck                    %{sdkbindir}/extcheck \
--slave %{_bindir}/idlj                     idlj                        %{sdkbindir}/idlj \
--slave %{_bindir}/jar                      jar                         %{sdkbindir}/jar \
--slave %{_bindir}/jarsigner                jarsigner                   %{sdkbindir}/jarsigner \
--slave %{_bindir}/javadoc                  javadoc                     %{sdkbindir}/javadoc \
--slave %{_bindir}/javah                    javah                       %{sdkbindir}/javah \
--slave %{_bindir}/javap                    javap                       %{sdkbindir}/javap \
--slave %{_bindir}/jdb                      jdb                         %{sdkbindir}/jdb \
--slave %{_bindir}/native2ascii             native2ascii                %{sdkbindir}/native2ascii \
--slave %{_bindir}/rmic                     rmic                        %{sdkbindir}/rmic \
--slave %{_bindir}/serialver                serialver                   %{sdkbindir}/serialver \
--slave %{_bindir}/jconsole                 jconsole                    %{sdkbindir}/jconsole \
--slave %{_bindir}/pack200                  pack200                     %{sdkbindir}/pack200 \
--slave %{_bindir}/unpack200                unpack200                   %{sdkbindir}/unpack200 \
%ifnarch x86_64
--slave %{_bindir}/HtmlConverter            HtmlConverter               %{sdkbindir}/HtmlConverter \
%endif
--slave %{_bindir}/apt                      apt                         %{sdkbindir}/apt
update-alternatives --install %{_jvmdir}/java-%{origin} java_sdk_%{origin} %{_jvmdir}/%{sdklnk} %{priority} \
--slave %{_jvmjardir}/java-%{origin}        java_sdk_%{origin}_exports     %{_jvmjardir}/%{sdklnk}
update-alternatives --install %{_jvmdir}/java-%{javaver} java_sdk_%{javaver} %{_jvmdir}/%{sdklnk} %{priority} \
--slave %{_jvmjardir}/java-%{javaver}       java_sdk_%{javaver}_exports      %{_jvmjardir}/%{sdklnk}
# We do not care if all/any of this actually succeeds
# Therefore errors are caught but messages are allowed

%postun
if [ $1 -eq 0 ]; then
  update-alternatives --remove java %{jrebindir}/java
  update-alternatives --remove \
    jce_%{javaver}_%{origin}_local_policy \
    %{_jvmprivdir}/%{name}/jce/vanilla/local_policy.jar
  update-alternatives --remove jre_%{origin}  %{_jvmdir}/%{jrelnk}
  update-alternatives --remove jre_%{javaver} %{_jvmdir}/%{jrelnk}
fi

%postun devel
if [ $1 -eq 0 ]; then
  update-alternatives --remove javac %{sdkbindir}/javac
  update-alternatives --remove java_sdk_%{origin}  %{_jvmdir}/%{sdklnk}
  update-alternatives --remove java_sdk_%{javaver} %{_jvmdir}/%{sdklnk}
fi

%files -f %{name}-%{version}.files
%defattr(-,root,root,0755)
%doc copyright license_en.txt notices.txt readmefirst.lnx.txt 
%dir %{_jvmdir}/%{sdkdir}
%{jvmjardir}
%ghost %{_jvmdir}/%{jredir}/lib/security/local_policy.jar
%ghost %{_jvmdir}/%{jredir}/lib/security/US_export_policy.jar
%{_jvmdir}/%{jrelnk}
%{_jvmjardir}/%{jrelnk}
%{_jvmdir}/%{jredir}/lib/fonts
%dir %{_jvmdir}/%{jredir}/lib/security
%config(noreplace) %{_jvmdir}/%{jredir}/lib/security/cacerts
%config(noreplace) %{_jvmdir}/%{jredir}/lib/security/java.policy
%config(noreplace) %{_jvmdir}/%{jredir}/lib/security/java.security
%config(noreplace) %{_jvmdir}/%{jredir}/lib/security/blacklist
%config(noreplace) %{_jvmdir}/%{jredir}/lib/security/trusted.libraries
%dir %{_jvmprivdir}/%{name}
%dir %{_jvmprivdir}/%{name}/jce
%dir %{_jvmprivdir}/%{name}/jce/vanilla
%config(noreplace) %{_jvmprivdir}/%{name}/jce/vanilla/*_policy.jar
%ifarch %{plugin_arches}
%{_datadir}/applications/jpackage-%{name}-webstart.desktop
%{_jvmdir}/%{jredir}/lib/locale
%{_datadir}/pixmaps/ibm-java-%{version}-%{release}.png
%exclude  %{_jvmdir}/%{jredir}/lib/*/*plugin*
%exclude  %{_jvmdir}/%{jredir}/lib/plugin.jar
%exclude  %{pluginpath}/%{pluginname}
%config(noreplace) %{_jvmdir}/%{jredir}/lib/security/javaws.policy
%endif
%ifarch ppc64
%config(noreplace) %{_jvmdir}/%{jredir}/lib/security/javaws.policy
%endif
# new in GA (0.0)
%{_jvmdir}/%{jredir}/lib/security.jar
%dir %{_jvmdir}/%{jredir}/.systemPrefs

%files devel
%defattr(-,root,root,0755)
%doc docs/* 
%dir %{_jvmdir}/%{sdkdir}/bin
%dir %{_jvmdir}/%{sdkdir}/include
%dir %{_jvmdir}/%{sdkdir}/lib
%{_jvmdir}/%{sdkdir}/bin/*
%{_jvmdir}/%{sdkdir}/include/*
%{_jvmdir}/%{sdkdir}/lib/*
%{_jvmdir}/%{sdklnk}
%{_jvmjardir}/%{sdklnk}
%ifarch %ix86 ppc s390
%{cgibindir}/java-rmi-%{version}.cgi
%endif

%files src
%defattr(-,root,root,0755)
%{_jvmdir}/%{sdkdir}/src.jar
%{_jvmdir}/%{sdkdir}/src.zip

%files demo
%defattr(-,root,root,0755)
%{demodir}
%ifarch %ix86

%files alsa -f %{name}-%{version}-alsa.files
%defattr(-,root,root,0755)
%endif

%files jdbc -f %{name}-%{version}-jdbc.files
%defattr(-,root,root,0755)

%ifarch %{plugin_arches}

%files plugin -f %{name}-%{version}-plugin.files
%defattr(644,root,root,0755)
%{_datadir}/applications/jpackage-%{name}-ControlPanel.desktop
%{_jvmdir}/%{jredir}/lib/%{__arch}/*plugin*
%{_jvmdir}/%{jredir}/lib/plugin.jar
%{pluginpath}/%{pluginname}
%endif

%files fonts
%defattr(0644,root,root,0755)
%if %{sles_version:1}0
%dir %{_datadir}/fonts
%endif
%dir %{fontdir}
%{fontdir}/*.ttf
%config(noreplace) %{fontdir}/fonts.alias
%ghost %{fontdir}/fonts.dir
%ghost %{fontdir}/fonts.scale
%ghost %{fontdir}/fonts.cache-1
%ghost %{fontdir}/XftCache
%ghost %{fontdir}/encodings.dir

%changelog
* Mon Feb  7 2011 mvyskocil@suse.cz
- add documentation and license files to compat packages
* Fri Dec 17 2010 mvyskocil@suse.cz
- fix bnc#659926 - VUL-0: IBM Java 6 SR9 released
  * CVE-2010-3553
  * CVE-2009-3555
  * CVE-2010-3562
  * CVE-2010-3557
  * CVE-2010-3558
  * CVE-2010-3563
  * CVE-2010-0771
  * CVE-2010-3550
  * CVE-2010-3549
  * CVE-2010-3551
  * CVE-2010-3555
  * CVE-2010-3556
  * CVE-2010-3559
  * CVE-2010-3548
  * CVE-2010-1321
  * CVE-2010-3565
  * CVE-2010-3567
  * CVE-2010-3566
  * CVE-2010-3568
  * CVE-2010-3541
  * CVE-2010-3569
  * CVE-2010-3571
  * CVE-2010-3572
  * CVE-2010-3560
  * CVE-2010-3573
  * CVE-2010-3574
* Thu Dec 16 2010 mvyskocil@suse.cz
- fix bnc#658220 - remove java-1_6_0-ibm-plugin from x86_64 CD
  * do not provide/obsolete old java plugins on x86_64
- fix bnc#659605 - java binary is missing in java-1_6_0-ibm-64bit
  * adjust baselibs.conf for targettype 64bit too
* Tue Nov 16 2010 mvyskocil@suse.cz
- sync priority between spec and baselibs.conf
* Mon Nov 15 2010 dmueller@suse.de
- fix typo in baselibs.conf
* Mon Nov 15 2010 mvyskocil@suse.cz
- 32bit plugin package for x86_64
* Wed Oct 27 2010 mvyskocil@suse.cz
- fix bnc#649241: IBM Java plugin is wronly packaged
  * make libnpjp2.so as a default plugin
  * create plugin subpackage for x86_64 too
- avoid duplicates and empty lines in /etc/{mailcap,mime.types}
* Tue Aug 10 2010 mvyskocil@suse.cz
- do not touch scripts in (jre)/bin - bnc#624224#c8
* Thu Jul 22 2010 mvyskocil@suse.cz
- fix bnc#624224 - VUL-0: Java 6 SR8 FP1 for SLES11 SP1
* Thu May  6 2010 mvyskocil@suse.cz
- fix bnc#603283 - VUL-1: java-1_6_0-ibm: IBM Java 1.6.0 SR8 to stop bypassing
  filters by using UTF-8 encoding
  * CVE-2008-5351
* Tue Mar  2 2010 mvyskocil@suse.cz
- fix [bnc#578134] - The IBM java6 is not recognizing the time zone information
* Tue Dec 22 2009 mvyskocil@suse.cz
- fixed bnc#561859 - VUL-0: IBM Java 6 SR7
* Thu Dec  3 2009 mvyskocil@suse.cz
- timezone 1.6.9s update (bnc#558342)
* Wed Oct 21 2009 mvyskocil@suse.cz
- Fixed bnc#548655: VUL-0: Update java-1_6_0-ibm to SR6
- Prevents bnc#538528 by disabling debug* packages
- Improved versioning - it now contains a _srX suffix with a number
  of current Service Refresh from IBM
* Mon Jun 29 2009 mvyskocil@suse.cz
- fixed bnc#516361: VUL-0: IBM Java 6 SR5
  updated to SR5
- fixed bnc#494536: Updating Java overwrites a custom certs
  Mark the following files as %%config(noreplace):
  * jre/lib/security/cacerts
  * jre/lib/security/java.policy
  * jre/lib/security/java.security
  * jre/lib/security/javaws.security (on x86, ppc and ppc64)
  * /usr/lib/jvm-private/java-1_6_0-sun/jce/vanilla/local_policy.jar
  * /usr/lib/jvm-private/java-1_6_0-sun/jce/vanilla/US_export_policy.jar
  (don't remove the policy files in jre/lib/security - they're just symlinks)
* Thu Apr  2 2009 mvyskocil@suse.cz
- fixed [bnc#489052]: IBM Java 1.4.2 SR13 / IBM Java 1.6.0 SR4
  updated to SR4
- used tzupdate macro to turn on/off the tzupdate like in Java Sun specs
- don't use xdelta for rpath fix (but still sourced due strange error of rpmbuild)
* Tue Feb  3 2009 mvyskocil@suse.cz
- fix of bnc#470821
  - baselibs.conf: return back a <version> for jvm-private
  - change a top level dir to java-1.6.0-ibm-1.6.0 to be consistent with
    other's JVM
* Mon Jan 26 2009 ro@suse.de
- baselibs.conf: replace <version> by 1.6.0 where needed
* Sat Jan 24 2009 schwab@suse.de
- Remove redundant require on libstdc++33.
* Fri Jan 16 2009 mvyskocil@suse.cz
- use a %%%%{javaver} in a top dir (bnc#466078)
- marked jtzu as NoSource
* Wed Jan  7 2009 mvyskocil@suse.cz
- fixed bnc#459800: Mismatch in the width and height of JList
  - added a java-font package to Requires
- remove a backup dir after timezone update
- disable a stripping
- do not index jars (may causes a lot of errors)
- use fdupes only on JRE and SDK/demo, the links from JRE to JDK will break the
  installation
* Tue Jan  6 2009 mvyskocil@suse.cz
- use the jtzu tool from http://www.ibm.com/ webpage (has a different
  checksum)
* Thu Dec 18 2008 mvyskocil@suse.cz
- update to SR3 - bnc#459763
- include a fixed jtzu-1.6.8i.zip from bnc#456140
* Thu Dec 11 2008 ro@suse.de
- update baselibs.conf (require alsa subpackage only on x86)
  (bnc#457737)
* Thu Nov 27 2008 ro@suse.de
- another fix for baselibs.conf (. vs _) (bnc#449438)
* Fri Oct 24 2008 ro@suse.de
- fix baselibs.conf
* Fri Oct 24 2008 kukuk@suse.de
- Replace compat-libstdc++ with libstdc++33
* Tue Oct 14 2008 mvyskocil@suse.cz
- prevent of bnc#432772: /usr/bin/java is not executable
  - use a `install -m 0755' instead of `cp' for wrapper-script installation
* Wed Oct  8 2008 mvyskocil@suse.cz
- fix of bnc#430026: Java plug-in for Firefox does not show up in plug-ins
  - install a jre/plugin dir and changed the pluginpath and a pluginname
- fix of some rpmlint errors and warnings:
  - use dos2unix on documentation
  - fix a duplicates in documentation
  - remove all Windows executables from installation
- disabled a RPATH test, because it fails on some architectures
- added samples dir to demo package (if exists)
* Fri Sep 19 2008 anosek@suse.cz
- updated to 1.6.0 sr2 (bnc#427342) (fate#305090)
- updated timezone data to version 1.6.8f
- fixed Missing .systemPrefs (bnc#394974)
* Wed Aug 20 2008 schwab@suse.de
- Fix up rpaths.
* Mon Jul 14 2008 schwab@suse.de
- Add unzip to BuildRequires.
* Tue Jul  1 2008 anosek@suse.cz
- updated to 1.6.0 sr1 (bnc#404983)
- updated timezone data (bnc#397378)
* Tue Apr 15 2008 mvyskocil@suse.cz
- update to 1.6.0 GA: VUL-0: IBM Java: multiple vulnerabilities [bnc#379038]
- CVE-2008-1196: A buffer overflow vulnerability in Java Web Start may allow an
  untrusted Java Web Start application that is downloaded from a website to
  elevate its privileges. For example, an untrusted Java Web Start application
  may grant itself permissions to read and write local files or execute local
  applications that are accessible to the user running the untrusted
  application.
- CVE-2008-1195: A vulnerability in the Java Runtime Environment may allow
  JavaScript(TM) code that is downloaded by a browser to make connections to
  network services on the system that the browser runs on, through Java APIs,
  This may allow files (that are accessible through these network services) or
  vulnerabilities (that exist on these network services) which are not
  otherwise normally accessible to be accessed or exploited.
- CVE-2008-1194: Two buffer overflow vulnerabilities may allow an untrusted
  applet or application to cause the Java Runtime Environment to crash.
- CVE-2008-1194: A buffer overflow vulnerability in the Java Runtime
  Environment image parsing code may allow an untrusted applet or application
  to create a denial-of-service condition, by causing the Java Runtime
  Environment to crash.
- CVE-2008-1193: A buffer overflow vulnerability in the Java Runtime
  Environment image parsing code allow an untrusted applet or application to
  elevate its privileges. For example, an application may grant itself
  permissions to read and write local files or execute local applications that
  are accessible to the user running the untrusted application.
- CVE-2008-1192: A vulnerability in the Java Plug-in may an untrusted applet to
  bypass same origin policy and leverage this flaw to execute local
  applications that are accessible to the user running the untrusted applet.
- CVE-2008-1191: A vulnerability in Java Web Start may allow an untrusted Java
  Web Start application to create files on the system that the untrusted
  application runs on and leverage these files to run local applications with
  the privileges of the user running the untrusted Java Web Start application.
- CVE-2008-1190: A vulnerability in Java Web Start may allow an untrusted Java
  Web Start application to elevate its privileges. For example, an application
  may grant itself permissions to read and write local files or execute local
  applications that are accessible to the user running the untrusted
  application.
- CVE-2008-1189: A buffer overflow vulnerability in the Java Runtime
  Environment may allow an untrusted applet or application to elevate its
  privileges. For example, an applet may grant itself permissions to read and
  write local files or execute local applications that are accessible to the
  user running the untrusted applet.
- CVE-2008-1188: Two buffer overflow vulnerabilities in Java Web Start may
  independently allow an untrusted Java Web Start application to elevate its
  privileges. For example, an untrusted Java Web Start application may grant
  itself permissions to read and write local files or execute local
  applications that are accessible to the user running the untrusted
  application.
- CVE-2008-1187: A vulnerability in the Java Runtime Environment with parsing
  XML data may allow an untrusted applet or application to elevate its
  privileges. For example, an applet may read certain URL resources (such as
  some files and web pages).
* Thu Feb 28 2008 anosek@suse.cz
- changed Requires: %%{_libdir}/libodbc.so, %%{_libdir}/libodbcinst.so
  to Requires: unixODBC [#326751]
* Mon Nov 26 2007 ro@suse.de
- fix fdupes call to avoid potential cross partition hardlink
* Thu Sep  6 2007 anosek@suse.cz
- added 32-bit and 64-bit specific provides
* Thu Jul 19 2007 stbinner@suse.de
- fix suse_update_desktop_file call
* Wed Jul  4 2007 dbornkessel@suse.de
- replace own %%fdupes implementation with the autobuild implementation
- delete predefined desktop files
* Fri May 25 2007 dbornkessel@suse.de
- first version, based on java-1_5_0-ibm
